/*
 * Some Random Functions <random.h>
 *
 * ܂܂ȗ[`
 *
 * VsX^C̗Q
 *
 * EŒ̈l EEEEEEEEEEdouble ran0( long *seed )
 * ES@\l EEEEEEEEdouble ran1( long *seed )
 * Ël EEEEEEEEEEEdouble ran2( long *seed )
 * Ew: ̒l,  1 EEEEEEEdouble expdev( long *seed )
 * EKEX:  0, U 1 EEEEEEdouble gasdev( long *seed )
 * EK}( ia)EEEEEEEEEEdouble gamdev( int ia, long *seed )
 * E|A\( xm)EEEEEEEEEdouble poidev( double xm, long *seed )
 * EQ(m pp, s n)EEEEEdouble bnldev( double pp, int n, long *seed )
 *
 * E̗Ɏɂ́Along^̐seedɔCӂ̒̕lČĂԁB
 * 
 * `mrhbX^C̗Q
 *
 * El int EEEEEEEEEEEEEint    i_rand()
 * El longEEEEEEEEEEEEElong   l_rand()
 * El doubleEEEEEEEEEEEEdouble d_rand()
 * Ew(  ave ) EEEEEEEEEdouble exp_rand( double ave )
 * EKEX(  ave, W΍ sig ) Edouble gas_rand( double ave, double sig )
 * E|A\(  ave ) EEEEEEEint    poi_rand( double ave )
 *
 * E̗Ɏseedɂ́Aꂼɗpӂꂽ֐*_srand()Ă.
 *
 *     i_srand( unsigned long seed )
 *     l_srand( unsigned long seed )
 *     d_srand( unsigned long seed )
 *   exp_srand( unsigned long seed )
 *   gas_srand( unsigned long seed )
 *   poi_srand( unsigned long seed )
 *
 * Copyleft 1994 Taiji YAMADA - please cite "Numerical Recipes in C"
 */
#if !defined(_RANDOM_H_)
#define _RANDOM_H_

void _random_h_error( char *mes )
{
  fprintf( stderr, "%s at random.h \n", mes );
}
/*
 * Park and Miller ɂŒ̈l
 */
#define IA 16807
#define IM 2147483647
#define AM (1.0)/IM
#define IQ 127773
#define IR 2836
#define MASK 123459876
double ran0( long *idum )
{
  long k;
  double ans;
  
  *idum ^= MASK;
  k = (*idum)/IQ;
  *idum = IA*(*idum-k*IQ)-IR*k;
  if ( *idum < 0 )
    *idum += IM;
  ans = AM*(*idum);
  *idum ^= MASK;
  return( ans );
}
/*
 * Bays and Durham ɂS@\l
 */
#define NTAB 32
#define NDIV (1+(IM-1)/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)
double ran1( long *idum )
{
  int j;
  long k;
  static long iy = 0, iv[NTAB];
  double temp;

  if ( *idum <= 0 || !iy ) {
    if ( -(*idum) < 1 )
      *idum = 1;
    else
      *idum = -(*idum);
    for ( j=NTAB+7; j>=0; j-- ){
      k = (*idum)/IQ;
      *idum = IA*(*idum-k*IQ)-IR*k;
      if ( *idum < 0 )
        *idum += IM;
      if ( j < NTAB )
        iv[j] = *idum;
    }
    iy = iv[0];
  }
  k = (*idum)/IQ;
  *idum = IA*(*idum-k*IQ)-IR*k;
  if ( *idum < 0 )
    *idum += IM;
  j = iy/NDIV;
  iy = iv[j];
  iv[j] = *idum;
  if ( (temp=AM*iy) > RNMX )
    return( RNMX );
  return( temp );
}
#undef IA
#undef IM
#undef AM
#undef IQ
#undef IR
#undef MASK
#undef NTAB
#undef NDIV
#undef EPS
#undef RNMX
/*
 * L'Ecuyer ɂ钷̈l
 */
#define IM1 2147483563
#define IM2 2147483399
#define AM (1.0)/IM1
#define IMM1 (IM1-1)
#define IA1 40014
#define IA2 40692
#define IQ1 53668
#define IQ2 52774
#define IR1 12211
#define IR2 3791
#define NTAB 32
#define NDIV (1+IMM1/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)
double ran2( long *idum )
{
  int j;
  long k;
  static long idum2 = 123456789;
  static long iy = 0, iv[NTAB];
  double temp;
  
  if ( *idum <= 0 || !iy ) {
    if ( -(*idum) < 1 )
      *idum = 1;
    else
      *idum = -(*idum);
    idum2 = (*idum);
    for ( j=NTAB+7; j>=0; j-- ){
      k = (*idum)/IQ1;
      *idum = IA1*(*idum-k*IQ1)-IR1*k;
      if ( *idum < 0 )
        *idum += IM1;
      if ( j < NTAB )
        iv[j] = *idum;
    }
    iy = iv[0];
  }
  k = (*idum)/IQ1;
  *idum = IA1*(*idum-k*IQ1)-IR1*k;
  if ( *idum < 0 )
    *idum += IM1;
  k = (idum2)/IQ2;
  idum2 = IA2*(*idum-k*IQ2)-IR2*k;
  if ( idum2 < 0 )
    idum2 += IM2;
  j = iy/NDIV;
  iy = iv[j] - idum2;
  iv[j] = *idum;
  if ( iy < 1 )
    iy += IMM1;
  if ( (temp=AM*iy) > RNMX )
    return( RNMX );
  return( temp );
}
#undef IM1
#undef IM2
#undef AM
#undef IMM1
#undef IA1
#undef IA2
#undef IQ1
#undef IQ2
#undef IR1
#undef IR2
#undef NTAB
#undef NDIV
#undef EPS
#undef RNMX
/*
 * w: ̒l,  1
 */
double expdev( long *idum )
{
  double dum;
  
  do
    dum = ran1( idum );
  while ( dum == 0.0 );
  return( -log( (double)dum ) );
}
/*
 * KEX:  0, U 1
 */
double gasdev( long *idum )
{
  static int iset = 0;
  static double gset;
  double fac, r, v1, v2;
  
  if ( iset == 0 ) {
    do{
      v1 = 2.0*ran1(idum)-1.0;
      v2 = 2.0*ran1(idum)-1.0;
      r = v1*v1+v2*v2;
    }while ( r >= 1.0 );
    fac = sqrt(-2.0*log(r)/r);
    gset = v1*fac;
    iset = 1;
    return( v2*fac );
  }else{
    iset = 0;
    return( gset );
  }
}
/*
 * K}( ia)
 */
double gamdev( int ia, long *idum )
{
  int j;
  double am, e, s, v1, v2, x, y;

  if ( ia < 1 ) _random_h_error( "Error in routine GAMDEV" );
  if ( ia < 6 ){
    x = 1.0;
    for ( j=1; j<=ia; j++ ) x *= ran1(idum);
    x = -log(x);
  }else{
    do {
      do {
	do {
	  v1 = 2.0*ran1(idum)-1.0;
	  v2 = 2.0*ran1(idum)-1.0;
	} while ( v1*v1+v2*v2 > 1.0 );
	y = v2/v1;
	am = ia-1;
	s = sqrt(2.0*am+1.0);
	x = s*y+am;
      } while ( x <= 0.0 );
      e = (1.0+y*y)*exp(am*log(x/am)-s*y);
    } while ( ran1(idum) > e );
  }
  return( x );
}
double gammln( double xx )
{
  int j;
  double x, tmp, ser;
  static double cof[6] = { 76.18009173,-86.50532033,24.01409822,
			     -1.231739516,0.120858003e-2,-0.536382e-5 };
  
  x = xx-1.0;
  tmp = x+5.5;
  tmp -= (x+0.5)*log(tmp);
  ser = 1.0;
  for ( j=0; j<=5; j++ ) {
    x += 1.0;
    ser += cof[j]/x;
  }
  return( -tmp+log(2.50662827465*ser) );
}
/*
 * |A\( xm)
 */
double poidev( double xm, long *idum )
{
  static double sq, alxm, g, oldm = (-1.0);
  double em,t,y;

  if ( xm < 12.0 ) {
    if ( xm != oldm ) {
      oldm = xm;
      g = exp(-xm);
    }
    em = -1;
    t = 1.0;
    do{
      em += 1.0;
      t *= ran1(idum);
    } while (t > g);
  }else{
    if ( xm != oldm ) {
      oldm = xm;
      sq = sqrt(2.0*xm);
      alxm = log(xm);
      g = xm*alxm-gammln(xm+1.0);
    }
    do{
      do{
	y = tan(M_PI*ran1(idum));
	em = sq*y+xm;
      }while ( em < 0.0 );
      em = floor(em);
      t = 0.9*(1.0+y*y)*exp(em*alxm-gammln(em+1.0)-g);
    }while ( ran1(idum) > t );
  }
  return( em );
}
/*
 * Q(m pp, s n)
 */
double bnldev( double pp, int n, long *idum )
{
  int j;
  static int nold = (-1);
  double am, em, g, angle, p, bnl, sq, t, y;
  static double pold=(-1.0), pc, plog, pclog, en, oldg;

  p = (pp <= 0.5 ? pp : 1.0-pp);
  am = n*p;
  if ( n < 25 ){
    bnl = 0.0;
    for ( j=1; j<=n; j++ )
      if ( ran1(idum) < p ) bnl += 1.0;
  }else if ( am < 1.0 ){
    g = exp(-am);
    t = 1.0;
    for ( j=0; j<=n; j++ ){
      t *= ran1(idum);
      if (t < g) break;
    }
    bnl = (j <= n ? j : n);
  }else{
    if ( n != nold ){
      en = n;
      oldg = gammln(en+1.0);
      nold = n;
    } if ( p != pold ) {
      pc = 1.0-p;
      plog = log(p);
      pclog = log(pc);
      pold = p;
    }
    sq = sqrt(2.0*am*pc);
    do{
      do{
	angle = M_PI*ran1(idum);
	y = tan(angle);
	em = sq*y+am;
      }while ( em < 0.0 || em >= (en+1.0) );
      em = floor(em);
      t = 1.2*sq*(1.0+y*y)
	*exp(oldg-gammln(em+1.0)-gammln(en-em+1.0)+em*plog+(en-em)*pclog);
    }while ( ran1(idum) > t );
    bnl = em;
  }
  if ( p != pp ) bnl = n-bnl;
  return( bnl );
}
/*
 * int^̈l[`Ǝ(seed)ݒ葱
 */
#define I_RAND_MAX 32767
static unsigned long _i_seed = 1;
int i_rand( void )
{
  return( ((_i_seed = 1664525L*_i_seed + 1013904223L)>>5)&I_RAND_MAX );
}
void i_srand( unsigned int _seed )
{
  srand( (unsigned long)_seed );
}
/*
 * long^̈l[`
 */
#define L_RAND_MAX 2147483647L
static unsigned long _l_seed = 1;
long l_rand( void )
{
  return( (_l_seed = 1664525L*_l_seed + 1013904223L)&L_RAND_MAX );
}
void l_srand( unsigned long _seed )
{
  _l_seed = _seed;
}
/*
 * double^̈l[`
 */
static long _ran_seed = -1;
double d_rand()
{
  return( ran1( &_ran_seed ) );
}
void d_srand( unsigned long _seed )
{
  _ran_seed = -_seed;
}
/*
 * w( ave)
 */
double exp_rand( double ave )
{
  double dum;
  
  do
    dum = ran1( &_ran_seed );
  while ( dum == 0.0 );
  return( -log(dum)*ave );
}
#define exp_srand(seed) d_srand(seed)
/*
 * KEX( ave, W΍ sig)
 */
double gas_rand( double _ave, double _sig )
{
  static int flg = !0;
  double r1, r2, nr1, nr2;

  if ( flg ){
    do; while ( (r1=ran1( &_ran_seed )) == 0.0 );
    r2 = ran1( &_ran_seed );
    nr1 = _sig*sqrt(-2.0*log(r1))*cos(2.0*M_PI*r2)+_ave;
    nr2 = _sig*sqrt(-2.0*log(r1))*sin(2.0*M_PI*r2)+_ave;
  }else{
    nr1 = nr2;
  }
  flg = !flg;
  return( nr1 );
}
/*
 * |A\(  ave )
 */
#define gas_srand(seed) d_srand(seed)
int poi_rand( double xm )
{
  static double sq, alxm, g, oldm = -1.0;
  double em, t, y;
  
  if ( xm < 12.0 ){
    if ( xm != oldm ){
      oldm = xm;
      g = exp( -xm );
    }
    em = -1;
    t = 1.0;
    do{
      em += 1.0;
      t *= ran1( &_ran_seed );
    }while ( t > g );
  }else{
    if ( xm != oldm ){
      oldm = xm;
      sq = sqrt( 2.0*xm );
      alxm = log( xm );
      g = xm*alxm - gammln( xm+1.0 );
    }
    do{
      do{
	y = tan( M_PI*ran1( &_ran_seed ) );
	em = sq*y + xm;
      }while ( em < 0.0 );
      em = floor( em );
      t = 0.9*(1.0+y*y)*exp(em*alxm-gammln(em+1.0)-g);
    }while ( ran1( &_ran_seed ) > t );
  }
  return( (int)em );
}
#define poi_srand(seed) d_srand(seed)
#endif _RANDOM_H_
